<?php

/*************************************************************
* Joomla Community Builder Customize Plugin
* @package Community Builder
* @author Stiggi <stiggi@voodootools.de>
* @link http://voodootools.de
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
*************************************************************/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
define( 'CTMBASEPATH', dirname(__FILE__).'/');

if (file_exists(CTMBASEPATH.'/language/'.$mosConfig_lang.'.php')) {
	include_once(CTMBASEPATH.'/language/'.$mosConfig_lang.'.php');
} else {
	include_once(CTMBASEPATH.'/language/english.php');
}

include("cssparser.php");

class getCustomizeTab extends cbTabHandler {
	/**
	* Constructor
	*/	
	function getCustomizeTab() {
		$this->cbTabHandler();
	}

	/**
	* Generates the HTML to display the user edit tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if 	ErrorMSG generated
	*/
	function getEditTab( $tab, $user, $ui) {
		global $my, $mosConfig_absolute_path, $mainframe, $mosConfig_live_site,$database;
		if(intval($my->id) < 1){
			mosNotAuth();
			return false;
		}
		// credits
		$footer = '<p align="center"><small>&copy;2007 idea by <a href="http://www.nightcity.nl" target="_blank">Lennox</a> :: code by <a href="http://www.voodootools.de" target="_blank">Stiggi</a></small></p>';
		// to change the enctype of the form use this piece of javascript

		// to avoid caching errors.
		$mainframe->addCustomHeadTag('<meta http-equiv="cache-control" content="no-cache">');
		$mainframe->addCustomHeadTag('<script src="'.$mosConfig_live_site
			. '/components/com_comprofiler/plugin/user/plug_cbcustomizetab/js/functions.js" type="text/javascript"></script>');
		// add colorpicker script
		?>
		<script type="text/javascript">
			var baseFolder="<?php echo $mosConfig_live_site; ?>/components/com_comprofiler/plugin/user/plug_cbcustomizetab/";
		</script>
		<?php
		$mainframe->addCustomHeadTag('<script src="'.$mosConfig_live_site
			. '/components/com_comprofiler/plugin/user/plug_cbcustomizetab/js/picker.js" type="text/javascript"></script>');
		// add png css workaround
		$css_link = '<link href="'.$mosConfig_live_site.'/components/com_comprofiler/plugin/user/plug_cbcustomizetab/png.css" rel="stylesheet" type="text/css" />';
		$mainframe->addCustomHeadTag($css_link);
		// add users css file
		if (file_exists(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css')) {
			$css_link = '<link href="'.$mosConfig_live_site.'/usercss/css_'.$user->id.'.css" rel="stylesheet" type="text/css" />';
			$mainframe->addCustomHeadTag($css_link);
		}

		$return = "<h3>\n".CT_CHANGE_YOUR_PROFILE."</h3>";

		$additionalJS ='';
		$additionalElement = 1;


		$css = new cssparser();
		// read CSS
		if (file_exists(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css')) {
			$css_content = file_get_contents(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css');
		} else {
			$css_content = '';
		}
		$css->ParseStr($css_content);		

		//Template selector by Mikko Rnkk
		//Adapted from tempate selector module
		//If CB Template Switcher is selected as a template, lets show a template selector
		 		
		if($mainframe->getTemplate()=="cb_template_switcher"){		
		
		$return.="<h4>Choose your base template</h4>";
		$database->setQuery("Select template from #__comprofiler where user_id=\n".$my->id);
		$cur_template=$database->loadResult();
	
	
		if($cur_template==null)
			$cur_template=$this->params->get('template');

		$titlelength =20 ;
		$preview_height =  90;
		$preview_width 	= 140;
		$show_preview 	= true;
		
		// Read files from template directory
		$template_path 	= "$mosConfig_absolute_path/templates";
		$templatefolder = @dir( $template_path );
		$darray = array();

		if ($templatefolder) {
			while ($templatefile = $templatefolder->read()) {		
				if ($templatefile != "." && $templatefile != ".." && $templatefile != ".svn" && $templatefile != "css" && $templatefile!='cb_template_switcher'  && is_dir( "$template_path/$templatefile" )  ) {
					if(strlen($templatefile) > $titlelength) {
						$templatename = substr( $templatefile, 0, $titlelength-3 );
						$templatename .= "...";
					} else {
						$templatename = $templatefile;
					}
					$darray[] = mosHTML::makeOption( $templatefile, $templatename );
				}
			}
		$templatefolder->close();
		}

		sort( $darray );

// Show the preview image
// Set up JavaScript for instant preview
		$onchange = "";
		if ($show_preview) {
			$onchange = "showimage()";
		
			$return.=
	
"<img src='templates/$cur_template/template_thumbnail.png' name='preview' border='1' width='$preview_width' height='$preview_height' alt='$cur_template' />\n".
"<script language='JavaScript1.2' type='text/javascript'>\n".

"<!--\n".
"	function showimage() {\n".
"		//if (!document.images) return;\n".
"		document.images.preview.src = 'templates/' + getSelectedValue( 'adminForm', 'template' ) + '/template_thumbnail.png';\n".
"	}\n".
"	function getSelectedValue( frmName, srcListName ) {\n".
"		var form = eval( 'document.' + frmName );\n".
"		var srcList = eval( 'form.' + srcListName );\n".
"\n".
"		i = srcList.selectedIndex;\n".
"		if (i != null && i > -1) {\n".
"			return srcList.options[i].value;\n".
"		} else {\n".
"			return null;\n".
"		}\n".
"	}\n".
"-->\n".
"</script><br>";

		}
		$return .= mosHTML::selectList( $darray, 'template', "id=\"mod_templatechooser_jos_change_template\" class=\"button\" onchange=\"$onchange\"",'value', 'text', $cur_template );
	
	}
		//End of template selector code
		
		// check if XML file exists, allowcustomization
		if (file_exists(CTMBASEPATH.'elements.xml')) {
//			echo (CT_NO_ELEMENTS_FOUND);
//			return false;
//		}

		$return .="<table>";


	// read XML file 
		$xmlDoc = new DOMIT_Lite_Document();
		$xmlDoc->resolveErrors( true );
		$filename = CTMBASEPATH.'elements.xml';
		if (!$xmlDoc->loadXML( $filename, false, true )) {
			echo (CT_CANNOT_LOAD_ELEMENTS_FILE.' '.$filename);
			return false;
		} else {
			$root = &$xmlDoc->documentElement;

			if ($root->getTagName() != 'elements') {
				echo (CT_ELEMENTSLIST_CORRUPT);
				return false;
			} else {
				
				// get all selectors
				$elements_nodes = &$root->childNodes;

				foreach($elements_nodes as $element_node) {

					if (!is_null($element_node)) {
						// selector name
						$selector = &$element_node->getAttribute( "selector" );
						$description = &$element_node->getAttribute( "desc" );
						
						$return .= $this->makeSelectorHeader($selector, $description);
						$row = 1;
						// get attributes
						$child_elements = $element_node->childNodes;

						foreach($child_elements as $child_element)
						{
							switch($child_element->getTagName()) {
								case 'attribute':  
									$attribute = $child_element->getText();
									$type = $child_element->getAttribute( "type");
									
									if ($type == 'set') {
										$set = $child_element->getAttribute( "set");
									}
									$name = 'ctm_'.base64_encode($selector.'---'.$attribute);
									
									//echo "<p>$selector --- $attribute -- $b -- $c</p>";
									$desc=$attribute; // maybe change to a real description
									
									$current = $css->Get($selector, $attribute);
									$current = trim(str_replace("!important", "", $current));
									
									
									$additionalJS .= 'var inp'.$additionalElement
												.' = document.getElementById(\''.$name.'\'); '
												.'if(inp'.$additionalElement.'){'
												.'addIbox(\''.$name.'\', \''
												.$selector.'\', \''.$attribute.'\');'
												.'addEvent(inp'.$additionalElement.', "change",'
												.'setColor);}';


									switch ($type) {
										case 'image':
											$return .= $this->makeImageRow($name, $desc, $row); 
											break;
										case 'color':
											$return .= $this->makeColorRow($name, $desc, $current, $row);
											$additionalJS .= 'if(inp'.$additionalElement.'){'
												.'attachColorPicker(inp'.$additionalElement.');}';
											 
											$additionalElement++;
											break;
										case 'text': 
											$return .= $this->makeTextRow($name, $desc, $current, $row);
											break;
										case 'set':
											$return .= $this->makeSetRow($name, $desc, $set, $current, $row);
											break;
									}
								break;
							}
							$row = ($row==1)?2:1;
						}
					}
				} 
			}
		}
		$return .= "</table>\n";
      }
		$return.=$footer;
		
		$mainframe->addCustomHeadTag('<script type="text/javascript">function init2(){'.$additionalJS.'} addLoadEvent(init2);</script>');
		return $return;
	}
	
	/**
	* Saves the user edit tab postdata into the tab's permanent storage
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @param array _POST data for saving edited tab content as generated with getEditTab
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function saveEditTab($tab, $user, $ui, $postdata) {
		global $my, $mosConfig_absolute_path, $mosConfig_live_site, $_FILES, $mainframe;
		if(intval($my->id) < 1) {
			mosNotAuth();
			return false;
		}
		
		//Template selector by Mikko Rnkk
		//If CB Template Switcher is selected as a template, save template value
		 		
		if($mainframe->getTemplate()=="cb_template_switcher"){
			global $database;
			$template=$_POST['template'];
			//Lets check that the input is valid			
			if(strpos('.',$template)===false && strpos('/',$template)===false
				&& strpos('\\',$template)===false &&
				file_exists("$mosConfig_absolute_path/templates/$template/index.php")){
				
				$database->setQuery("update #__comprofiler set template ='$template' where user_id=".$my->id);
				$database->query();			
			}
		}
		// read CSS
		$css = new cssparser();
		// read CSS
		if (file_exists(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css')) {
			$css_content = file_get_contents(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css');
		} else {
			$css_content = '';
		}
		$css->ParseStr($css_content);		
		$error = '';
		// read XML file 
		$xmlDoc = new DOMIT_Lite_Document();
		$xmlDoc->resolveErrors( true );
		$filename = CTMBASEPATH.'elements.xml';
		if (!$xmlDoc->loadXML( $filename, false, true )) {
			echo (CT_CANNOT_LOAD_ELEMENTS_FILE.' '.$filename);
			return false;
		} else {
			$root = &$xmlDoc->documentElement;

			if ($root->getTagName() != 'elements') {
				echo (CT_ELEMENTSLIST_CORRUPT);
				return false;
			} else {
				
				// get all selectors
				$elements_nodes = &$root->childNodes;

				foreach($elements_nodes as $element_node) {

					if (!is_null($element_node)) {
						// selector name
						$selector = &$element_node->getAttribute( "selector" );
						
						$css_new .= $selector . '{';

						// get attributes
						$child_elements = $element_node->childNodes;

						foreach($child_elements as $child_element)
						{
							switch($child_element->getTagName()) {
								case 'attribute':  
									$attribute = $child_element->getText();
									$type = $child_element->getAttribute( "type");
									
									if ($type == 'set') {
										$set = $child_element->getAttribute( "set");
									}
									$name = 'ctm_'.base64_encode($selector.'---'.$attribute);
									
									$current = $css->Get($selector, $attribute);
									$current = trim(str_replace("!important", "", $current));
									
									switch ($type) {
										case 'image':
											$newimage = false;
											$fname = $child_element->getAttribute( "fname");
											
											//if(($_FILES[$name]['size'] > 0) && ($temp = getimagesize($_FILES[$name]['tmp_name']))){
												// extract extension
												function qmimetype($filen) {
													$array = explode(".", $filen);
													$nr    = count($array);
													$ext  = $array[$nr-1];
												   foreach(file('/usr/local/apache/etc/mime.types') as $line)
													 if(preg_match('/^([^#]\S+)\s+.*'.$ext.'.*$/',$line,$m))
													   return $m[1];
												   //return 'application/octet-stream';
												  }
												$mime = qmimetype($_FILES[$name]['name']);
												$ok = false;
											   if($mime=="image/jpeg" || $mime=="image/pjpeg") {
												 // Mime type is correct
												 // Check extension
												 $array = explode(".", $_FILES[$name]['name']);
												 $nr    = count($array);
												 $ext  = $array[$nr-1];
												 if($ext=="jpg" || $ext=="jpeg") {
												   $ok = true;
												 }
											   } else if($mime=="image/gif") {
												 // Mime type is correct
												 // Check extension
												 $array = explode(".", $_FILES[$name]['name']);
												 $nr    = count($array);
												 $ext  = $array[$nr-1];
												 if($ext=="gif") {
												   $ok = true;
												 }
											   } else if($mime=="image/png") {
												 // Mime type is correct
												 // Check extension
												 $array = explode(".", $_FILES[$name]['name']);
												 $nr    = count($array);
												 $ext  = $array[$nr-1];
												 if($ext=="png") {
												   $ok = true;
												 }
											   }
											   											   
											   if($ok == true){
													// delete old files
													foreach(glob('../../../../../images/userimages/img_'.$fname.'_'.$user->id.'*') as $fn) {
														unlink($fn); 
													}
													
													// move current file
													$target_path = $mosConfig_absolute_path.'/images/userimages/img_'.$fname.'_'.$user->id.'.'.$ext;
													
													if(move_uploaded_file($_FILES[$name]['tmp_name'], $target_path)) {
														//$echo = "The file ".  basename( $_FILES[$name]['tmp_name']). 
														//" has been uploaded";
													} else{
														$echo = "There was an error uploading the file, please try again!";
													}
													
													$newimage = true;
													
													//chmod image
													@chmod ($target_path, 0755);
											
												}
	
												$removeimage = $postdata['remove_'.$name];
	
												if ($newimage) {
													$css_new .= 'background-image: url(../../../images/userimages/img_'.$fname.'_'.$user->id.'.'.$ext.') !important;'.$echo;
												} else if (!$removeimage){ 
													$current = $css->Get($selector, $attribute);
													$current = trim(str_replace("!important", "", $current));
													$css_new .= 'background-image:'.$current.' !important;';
												} else {
													$css_new .= $echo;
												}
											break;
											
										case 'set':
											$options = explode(';', $set);
											if (!in_array($postdata[$name], $options)) {
												//$error .= 'No valid value set in field '.$selector. ' - ' .$attribute;
											} else {
												$css_new .= $attribute.':'.addslashes($postdata[$name]).' !important;';
											} 
											break;
										case 'color':
											if (!eregi("^#([0-9a-f]{6})$", trim($postdata[$name]))){
												//$error .= 'No valid color set in field '.$selector. ' - ' .$attribute;
											} else {
												$css_new .= $attribute.':'.addslashes($postdata[$name]).' !important;';
											}
											break;
										default:
											$css_new .= $attribute.':'.addslashes($postdata[$name]).' !important;';
											break;
									}
								break;
							}
						}
						$css_new .= "}\n";
					}
				}
			}
		}
		if (!$error == '') {
			$this->_setErrorMSG($error);
			return false;
		} else {
			file_put_contents(CTMBASEPATH.'../../../../../usercss/css_'.$user->id.'.css', $css_new);
			return true;
		}
	}

	function getDisplayTab($tab,$user,$ui) {
		global $mosConfig_live_site, $mainframe;
		$css_link = '<link href="'.$mosConfig_live_site.'/usercss/css_'.$user->id.'.css" rel="stylesheet" type="text/css" />';
		$mainframe->addCustomHeadTag($css_link);

		
	}
	
	function makeImageRow($name, $desc, $row) {
		$return = '<tr><td class="sectiontableentry'.$row.'">'.$desc.':</td>'
			.'<td class="sectiontableentry'.$row.'"><input type="hidden" name="MAX_FILE_SIZE" value="500000" /><input type="file" name="'.$name.'" size="20"/>'
			.'<br/><input type="checkbox" name="remove_'.$name.'"/> '.CT_SET_BOX_TO_REMOVE
			.'</td></tr>';
		return $return; 
	}
	
	function makeColorRow($name, $desc, $current, $row){
		$return = '<tr class="row'.$row.'">'
			.'<td class="sectiontableentry'.$row.'">'.$desc.':</td>' 
			.'<td class="sectiontableentry'.$row.'"><input size="7" id="'.$name.'" name="'.$name.'" '
			.'value="'.$current.'" onPress="openPallete(\''.$name.'\', 0, true);" /><a href="javascript: openPallete(\''.$name.'\', 0, true)">Pick!</a></td></tr>';
		return $return;
	}
	
	function makeTextRow($name, $desc, $current, $row) {
		$return = '<tr class="row'.$row.'">'
			.'<td class="sectiontableentry'.$row.'">'.$desc.':</td>' 
			.'<td class="sectiontableentry'.$row.'"><input size="20" id="'.$name.'" name="'.$name.'" '
			.'value="'.$current.'" /></td></tr>';
		return $return;
	}
	
	function makeSetRow($name, $desc, $set, $current, $row) {
		$return = '<tr class="row'.$row.'">'
			.'<td class="sectiontableentry'.$row.'">'.$desc.':</td>' 
			.'<td class="sectiontableentry'.$row.'">'
			.'<select name="'.$name.'" size="1" class="input" id="'.$name.'" />';
			
			$options = explode(';', $set);
			for ($i=0;$i<count($options);$i++) {
				if ($options[$i]==$current) {
					$selected = 'selected';
				} else {
					$selected = '';
				}
				$o .= '<option '.$selected.' value="'.$options[$i].'">'.$options[$i].'</option>';
			}
		$return .= $o.'</select></td></tr>';
		return $return;
	}
	
	function makeSelectorHeader($selector, $description){
		$return = '<tr class="sectiontableheader"><td>'.$selector.'</td><td>'.$description.'</td></tr>';
		return $return;
	}
	
	function loadTemplateList($name,$value,$control_name) {
	
	global $database, $mainframe;
	global $mosConfig_absolute_path, $mosConfig_list_limit;

	$templateBaseDir = mosPathName( $mosConfig_absolute_path . '/templates' );

	$rows = array();
	$rowid=0;
	// Read the template dir to find templates
	$templateDirs		= mosReadDirectory($templateBaseDir);

	// Check that the directory contains an xml file

	foreach($templateDirs as $templateDir) {
		$dirName = mosPathName($templateBaseDir . $templateDir);
		$xmlFilesInDir = mosReadDirectory($dirName,'.xml$');

		foreach($xmlFilesInDir as $xmlfile) {
			// Read the file to see if it's a valid template XML file
			$xmlDoc = new DOMIT_Lite_Document();
			$xmlDoc->resolveErrors( true );
			if (!$xmlDoc->loadXML( $dirName . $xmlfile, false, true )) {
				continue;
			}

			$root = &$xmlDoc->documentElement;

			if ($root->getTagName() != 'mosinstall') {
				continue;
			}
			if ($root->getAttribute( 'type' ) != 'template') {
				continue;
			}

			$row = new StdClass();
			$row->id 		= $rowid;
			$row->directory = $templateDir;
			$element 		= &$root->getElementsByPath('name', 1 );
			$row->name 		= $element->getText();

			$element 		= &$root->getElementsByPath('creationDate', 1);
			$row->creationdate = $element ? $element->getText() : 'Unknown';

			$element 		= &$root->getElementsByPath('author', 1);
			$row->author 	= $element ? $element->getText() : 'Unknown';

			$element 		= &$root->getElementsByPath('copyright', 1);
			$row->copyright = $element ? $element->getText() : '';

			$element 		= &$root->getElementsByPath('authorEmail', 1);
			$row->authorEmail = $element ? $element->getText() : '';

			$element 		= &$root->getElementsByPath('authorUrl', 1);
			$row->authorUrl = $element ? $element->getText() : '';

			$element 		= &$root->getElementsByPath('version', 1);
			$row->version 	= $element ? $element->getText() : '';

			$rows[] = $row;
			$rowid++;
		}
	}
	$templateList=array();
	foreach ($rows as $row) {
			if($row->directory!='cb_template_switcher')
				$templateList[] = mosHTML::makeOption( $row->directory, $row->name);
	}
		$valAsObj = array_map(create_function('$v', '$o=new stdClass(); $o->value=$v; return $o;'), explode("|*|", $value ));

		return moscomprofilerHTML::selectList( $templateList, $control_name .'['. $name .'][]', 'size="4" multiple="multiple"', 'value', 'text', $valAsObj, true );	
		
	}

}
?>
